#include <stdio.h>
#include "stm32f4xx.h"


int Java_app_RTC_RTCGetTime(void) {
	int time;
	uint8_t sec;
	uint8_t min;
	uint8_t hr;
	
	
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, 0x68<<1, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) __NOP();
	I2C_SendData(I2C3, 0);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, 0x68<<1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED)) __NOP();
	
	I2C_AcknowledgeConfig(I2C3, ENABLE);
	I2C_GenerateSTOP(I2C3, DISABLE);
	while( !I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_RECEIVED)) __NOP();
	sec = I2C_ReceiveData(I2C3);
	
	I2C_AcknowledgeConfig(I2C3, ENABLE);
	I2C_GenerateSTOP(I2C3, DISABLE);
	while( !I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_RECEIVED)) __NOP();
	min = I2C_ReceiveData(I2C3);

	I2C_AcknowledgeConfig(I2C3, DISABLE);
	I2C_GenerateSTOP(I2C3, ENABLE);
	while( !I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_RECEIVED)) __NOP();
	hr = I2C_ReceiveData(I2C3);
	
	time = hr<<16 | min<<8 | sec;
	return time;
}
void Java_app_RTC_RTCSetTime(int time) {
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, 0x68<<1, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) __NOP();
	I2C_SendData(I2C3, time & 0x0);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	I2C_SendData(I2C3, time & 0x7F);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	I2C_SendData(I2C3, (time >> 8) & 0x7F);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	I2C_SendData(I2C3, (time >> 16) & 0x3F);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	I2C_GenerateSTOP(I2C3, ENABLE);
}

void Java_app_RTC_RTCInit(void) {
	//Read sec register to check if clock is enabled
    I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, 0x68<<1, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) __NOP();
	I2C_SendData(I2C3, 0);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, 0x68<<1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED)) __NOP();
	
	I2C_AcknowledgeConfig(I2C3, DISABLE);
	I2C_GenerateSTOP(I2C3, ENABLE);
	while( !I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_RECEIVED)) __NOP();
	uint8_t sec = I2C_ReceiveData(I2C3);

	if(sec & 0x80) {
	//start oscillator (clear bit 7)
		I2C_GenerateSTART(I2C3, ENABLE);
		while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
		I2C_Send7bitAddress(I2C3, 0x68<<1, I2C_Direction_Transmitter);
		while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) __NOP();
		I2C_SendData(I2C3, sec & 0x0);
		while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
		I2C_SendData(I2C3, sec & 0x7F);
		while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
		I2C_GenerateSTOP(I2C3, ENABLE);
	}
}
